% fft16sim.m:   16 point complex fft simulation program
% author:       Duweitao
% date:         2005 Dec 25th

clear
clc

PI = pi;
N = 16;
exp_factor = -j*2*PI/N;
twiddle = zeros(4,4);
in = zeros(N,1);
out1 = zeros(N,1);
out2 = zeros(N,1);
buf1 = zeros(4,4);
buf2 = zeros(4,4);
buf3 = zeros(4,4);
buf4 = zeros(4,4);


% generate input data
for(ii = 0:N-1)
  in(ii+1) = ii+ j * (ii*2);
end

%  remap input by row, 1d to 2d
for( ii = 0:3)
  buf1(ii+1,:) = in(ii*4+1: ii*4+4) .';
end


% generate twiddle factor
for( ii = 0:3)
  for(jj = 0:3)
    twiddle(ii+1, jj+1) = exp(exp_factor * ii * jj);
  end
end

% column fft
for(ii = 0:3)
  buf2(:,ii + 1) = fft(buf1(:,ii+1));
end

% twiddle
buf3 = buf2 .* twiddle;

% row fft
for(ii = 0:3)
  buf4(ii + 1,:) = fft(  buf3(ii+1,:).' ).';
end

%  remap output by column, 2d to 1d
for( ii = 0:3)
  out1(ii*4+1: ii*4+4) = buf4(:,ii+1);
end
% the matlab standard result
out2 = fft(in);

diff = abs(out1 - out2);
