#ifndef _CFFT16_H
#define _CFFT16_H

typedef struct {float r; float i;} cfft_t;

// 4 point fft internal data structure
typedef struct {
    // no use pointer only for course demostration
    cfft_t * noUsePointer1;
    cfft_t * noUsePointer2;
    cfft_t * noUsePointer3;
    cfft_t * noUsePointer4;
    cfft_t * noUsePointer5;
    cfft_t * noUsePointer6;
    cfft_t * noUsePointer7;
    cfft_t * noUsePointer8;
    cfft_t * noUsePointer9;
    cfft_t * noUsePointer10;
    cfft_t * noUsePointer11;
    cfft_t * noUsePointer12;
    cfft_t * noUsePointer13; 
    cfft_t *inputBuf;   // copy input data here
} cfft4plan_t;

// 16 point fft internal data structure
typedef struct {
    cfft_t *inputBuf;   // copy input data here
    cfft_t *turnBuf;    // after column FFT data turn buffer
    cfft_t *twiddle;    // twiddle factor buffer
    cfft4plan_t *cfft4planHandle;
} cfft16plan_t;


int cfft16_init(cfft16plan_t *cfft16planHandle);
// in place fft support
int cfft16_proc(
      cfft16plan_t *cfft16planHandle,
      cfft_t *in,
      cfft_t *out);
int cfft16_close(cfft16plan_t *cfft16planHandle);

int cfft4_init(cfft4plan_t *cfft4planHandle);
// in place fft support
int cfft4_proc(
      cfft4plan_t *cfft4planHandle,
      cfft_t *in,
      cfft_t *out);
int cfft4_close(cfft4plan_t *cfft4planHandle);

void ComplexPrint(char *name, cfft_t *data, int N);

#endif